<template>
	<TitleHeader :title="$t('pageTitle.ingredients')" :header="$t(`rightMenu.ingredients`)" />
	<DZDisclaimer help round content="ingredients.disclaimer" />
	<table>
		<tbody>
			<tr>
				<th class="icon"></th>
				<th class="name">{{ $t('ingredients.tname') }}</th>
				<th class="stock">{{ $t('ingredients.tstock') }}</th>
				<th v-if="isClan" class="clan"></th>
			</tr>

			<Tippy
				theme="normal"
				tag="tr"
				v-for="(ingredient, index) in ingredientList"
				:key="ingredient.name"
				:class="{
					full: ingredient.quantity >= ingredient.maxQuantity,
					even: (index + 1) % 2 == 0
				}"
			>
				<td class="icon">
					<img :src="getImgURL('ingredients', ingredient.name)" :alt="ingredient.name" />
				</td>
				<td class="name">{{ $t(`ingredients.name.${ingredient.name}`) }}</td>
				<td class="stock" v-if="ingredient.quantity !== 0">{{ ingredient.quantity }}/{{ ingredient.maxQuantity }}</td>
				<td v-if="isClan" class="stock">
					<DZInput
						type="number"
						:value="giveAway[index].quantity"
						@input="giveAway[index].quantity = +$event.target.value"
						:max="ingredient.quantity"
						min="0"
					/>
				</td>
				<td class="stock" v-else>--</td>

				<template #content>
					<h1 v-html="formatContent($t(`ingredients.name.${ingredient.name}`))" />
					<p v-html="formatContent($t(`ingredients.description.${ingredient.name}`))" />
				</template>
			</Tippy>
		</tbody>
	</table>
	<DZButton v-if="isClan" @click="giveToClan()">{{ $t(`clan.ingredients.giveAway`) }}</DZButton>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import { IngredientFiche } from '@drpg/core/models/ingredient/IngredientFiche';
import { ClanService, IngredientsService } from '../services/index.js';
import TitleHeader from '../components/utils/TitleHeader.vue';
import EventBus from '../events/index.js';
import { errorHandler } from '../utils/index.js';
import { playerStore } from '../store/index.js';
import DZInput from '../components/common/DZInput.vue';
import DZButton from '../components/common/DZButton.vue';
import { ingredientList } from '@drpg/core/models/ingredient/ingredientList';
import DZDisclaimer from '../components/common/DZDisclaimer.vue';

export default defineComponent({
	name: 'Ingredients',
	components: {
		DZDisclaimer,
		DZButton,
		DZInput,
		TitleHeader
	},
	data() {
		return {
			ingredientList: [] as Array<IngredientFiche>,
			playerStore: playerStore(),
			bidValue: 0,
			giveAway: [] as Array<IngredientFiche>
		};
	},
	async mounted(): Promise<void> {
		await this.load();
	},
	methods: {
		async load() {
			EventBus.emit('isLoading', true);
			try {
				const unsortedIngredients = await IngredientsService.getAllIngredients();
				this.ingredientList = this.sortIngredientsById(unsortedIngredients);
				this.giveAway = this.ingredientList.map(ingredient => {
					return { ...ingredient, quantity: 0 };
				});
				EventBus.emit('isLoading', false);
			} catch (err) {
				errorHandler.handle(err, this.$toast);
				return;
			}
		},
		sortIngredientsById(ingredients: Array<IngredientFiche>): Array<IngredientFiche> {
			return ingredients.sort((a, b) => a.ingredientId - b.ingredientId);
		},
		async giveToClan() {
			const gold = this.giveAway
				.filter(a => (a.quantity ?? 0) > 0)
				.reduce(
					(acc, cur) =>
						acc +
						(Object.values(ingredientList).find(a => a.ingredientId === cur.ingredientId)?.price ?? 0) *
							(cur.quantity ?? 0),
					0
				);
			const res = confirm(this.$t(`ingredients.giveAway.confirm`, { gold: gold }));
			if (res) {
				try {
					await ClanService.giveIngredient(
						this.playerStore.getClanId!,
						this.giveAway
							.filter(a => a.quantity && a.quantity > 0)
							.map(i => {
								return { itemId: i.ingredientId, quantity: i.quantity! };
							})
					);
				} catch (err) {
					errorHandler.handle(err, this.$toast, this.$t);
					return;
				}
				await this.load();
			}
		}
	},
	computed: {
		isClan(): boolean {
			if (this.playerStore.getClanId) {
				return true;
			} else {
				return false;
			}
		}
	}
});
</script>

<style lang="scss" scoped>
table {
	width: 100%;
	margin-top: 10px;
	margin-bottom: 5px;
	background-color: #ecbd84;
	border-collapse: separate;
	border-spacing: 1px;
	tr {
		display: table-row;
		cursor: help;
		th {
			font-size: 8pt;
			text-shadow: 1px 1px 0px #356847;
			height: 41px;
			vertical-align: bottom;
			color: #fffdba;
			text-transform: uppercase;
			font-weight: bold;
			letter-spacing: 1pt;
			text-align: left;
			white-space: nowrap;
			border: 1px solid #356847;
			background-color: #c64e36;
			background-image: url('../assets/background/table_header.webp');
			background-position: left bottom;
			max-width: 222px;
			&.name {
				padding-left: 4px;
				padding-right: 4px;
				padding-bottom: 8px;
				max-width: 200px;
			}
			&.icon {
				width: 32px;
			}
			&.stock {
				padding-left: 4px;
				padding-right: 4px;
				padding-bottom: 8px;
				max-width: 15px;
			}
		}
		td {
			font-size: 16px;
			font-family: 'Trebuchet MS', Arial, sans-serif;
			color: #710;
			background-color: #f3ca92;
			border: 1px solid #c88f44;
			background-image: url('../assets/background/table_cell.webp');
			background-position: -10px 0px;
			&.name {
				padding: 1px 5px;
				max-width: 222px;
			}
			&.stock {
				padding: 1px 5px;
				width: 52px;
			}
		}
		&.full td {
			background-image: url('../assets/background/table_cell_hover.webp') !important;
			background-position: -10px 0px;
			color: #fffdba;
		}
		&.even td {
			background-image: url('../assets/background/table_cell_even.webp');
			background-position: -10px 0px;
		}
	}
}
</style>
